<template>
  <v-row no-gutters>
    <v-col class="ma-5">
      <title-zone
        class="mb-10"
        :title="title"
      />
      <general-info class="mb-10" />
      <orders-info class="mb-10" />
      <vehicles-info class="mb-10" />
      <v-row no-gutters justify="center" class="mb-16" v-if="routeReady">
        <v-col cols="4">
          <v-row no-gutters justify="center">
            <v-btn
              block
              color="primary"
              :loading="confirmLoading"
              @click="confirmDispatch"
            >
              Confirmar atención de despacho
            </v-btn>
          </v-row>
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions, mapGetters, mapState } from 'vuex';
import GeneralInfo from './GeneralInfo';
import OrdersInfo from './OrdersInfo';
import VehiclesInfo from './VehiclesInfo';
import { hashId } from '~/helpers/format/ids';
import TitleZone from '~/components/Common/Page/TitleZone';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'DispatchDetails',
  components: {
    TitleZone,
    GeneralInfo,
    OrdersInfo,
    VehiclesInfo,
  },
  data: () => ({
    confirmLoading: false,
    loading: false,
  }),
  computed: {
    dispatchId() {
      return this.$route.params.id;
    },
    title() {
      return `Despacho programado ${hashId({ id: this.dispatchId })}`;
    },
    ...mapState({
      baseUrls: state => state.programming.dispatches.baseUrl,
      dispatch: state => state.programming.dispatches.current.dispatch,
    }),
    ...mapGetters({
      uri: 'programming/dispatches/allRouteUri',
    }),
    goToGoogleMaps() {
      return this.baseUrls + this.uri;
    },
    routeReady() {
      const state = this.dispatch?.routeRequestState ?? null;
      return state === 'GENERADO';
    },
  },
  async mounted() {
    await this.getCurrentDispatchDetails();
  },
  methods: {
    ...mapActions({
      getDispatchDetails: 'programming/dispatches/getDispatchDetails',
      confirmCurrentDispatch: 'programming/dispatches/confirmCurrentDispatch',
    }),
    async getCurrentDispatchDetails() {
      try {
        this.loading = true;
        await this.getDispatchDetails({ dispatchId: this.dispatchId });
      } catch (e) {
        this.$toast.error('No se ha podido obtener el despacho programado', errorOptions);
      }
      this.loading = false;
    },
    async confirmDispatch() {
      try {
        this.confirmLoading = true;
        await this.confirmCurrentDispatch({ dispatchId: this.dispatchId });
        await this.$router.push('/programacion/despachos');
        this.$toast.success('Se ha confirmado el despacho de los pedidos programados', successOptions);
      } catch (e) {
        this.$toast.error('No se ha podido confirmar el despacho de los pedidos', errorOptions);
      }
      this.confirmLoading = false;
    },
  },
};
</script>
